package com.perisic.jshadow;
/**
* A common base class for all shadows (dynamic version). 
* <p>
* For a description of the functionality of the shadow concept see 
* <a href="http://perisic.com/shadow">http://perisic.com/shadow</a>.
* <p>
* Note that a shadow cannot be shadowed. However an object or class can have
* multiple shadows. 
* 
*<UL>
*<li> First version: 16.09.2004
*<li>
* Copyright: (c) Marc Conrad, 2004
*<li>
* See http://perisic.com/shadow for information about this package. 
*<li>The com.perisic.shadow library is distributed under the terms of the 
* <a href="http://www.gnu.org/copyleft/lesser.html" target="_blank">
GNU Lesser General Public License (LGPL)</a>. 
*<li> If you require the package under a different licence please contact me.
*<li> disclaimer: The classes are provided "as is".
* There is no warranty implied by using the com.perisic.shadow package.
* <li> Note: This class needs a special adapted version of the jikes compiler (available on
* <a href="http://perisic.com/shadow">http://perisic.com/shadow</a>) 
* for successful compilation. Compile this 
*      class with the command jikes -dy
* </UL>
*/
public abstract class Shadow {

/** 
*    contains a reference to the object that is shadowed.
*/
     private Shadowable theShadowOwner;
     
/**
*     Constructed by child class only
*/
     protected Shadow() { }

/**
*    Initialization of the shadow. This method is only called 
*    automatically by the shadowed object upon construction.
*     
*    @param shadowOwner The object that is shadowed
*/
     void initShadow(Shadowable shadowOwner) {
        theShadowOwner = shadowOwner; 
        }
        
/**
*    Returns the object that is shadowed by this shadow. 
*    @return The object shadowed by this. 
*/
     public Shadowable shadowOwner() {
        return theShadowOwner;
        }
     }
